indexing

	description: "Base class for a header field in a MIME message."

	author: "Berend de Boer"
	date: "$Date: 2004/01/02 $"
	revision: "$Revision: #3 $"


deferred class

	EPX_MIME_FIELD


feature -- Output

	append_to_string (s: STRING) is
			-- Stream contents of MIME structure to a STRING.
		require
			s_not_void: s /= Void
		do
			s.append_string (name)
			s.append_string (once_space_colon)
			s.append_string (value)
			s.append_string (once_crlf)
		end


feature -- Access

	name: STRING is
			-- Name of MIME field. Names are case-insensitive.
		deferred
		ensure
			name_valid: is_valid_mime_name (Result)
		end

	value: STRING is
			-- Value of a field.
		deferred
		ensure
			value_not_void: value /= Void
		end


feature -- State

	is_valid_mime_name (a_name: STRING): BOOLEAN is
			-- Is `a_name' a valid MIME field name?
			-- Implementation not yet complete.
		do
			Result :=
				a_name /= Void and then
				not a_name.is_empty and then
				not a_name.has (' ') and then
				not a_name.has ('%T') and then
				not a_name.has ('%R') and then
				not a_name.has ('%N') and then
				not a_name.has (':')
		end


feature {NONE} -- Once strings

	once_crlf: STRING is "%R%N"
	once_space_colon: STRING is ": "


end
