indexing

	description:
		"Scanner for mime messages."

	standards:
		"Based on RFC 2822, 2045 and 2047."

	known_bugs:
		"1. B encoding not decoded."

	author: "Berend de Boer"
	date: "$Date: $"
	revision: "$Revision: $"


class

	EPX_MIME_SCANNER


inherit

	YY_COMPRESSED_SCANNER_SKELETON
		export
			{EPX_MIME_PARSER} yyEnd_of_file_character
		redefine
			make
		end

	UT_CHARACTER_CODES
		export {NONE} all end

	KL_CHARACTER_ROUTINES
		export
			{NONE} all
		end


creation

	make


feature -- Status report

	valid_start_condition (sc: INTEGER): BOOLEAN is
			-- Is `sc' a valid start condition?
		do
			Result := (INITIAL <= sc and sc <= DATE)
		end

feature {NONE} -- Implementation

	yy_build_tables is
			-- Build scanner tables.
		do
			yy_nxt ?= yy_nxt_template
			yy_chk ?= yy_chk_template
			yy_base ?= yy_base_template
			yy_def ?= yy_def_template
			yy_ec ?= yy_ec_template
			yy_meta ?= yy_meta_template
			yy_accept ?= yy_accept_template
		end

	yy_execute_action (yy_act: INTEGER) is
			-- Execute semantic action.
		do
if yy_act <= 56 then
if yy_act <= 28 then
if yy_act <= 14 then
if yy_act <= 7 then
if yy_act <= 4 then
if yy_act <= 2 then
if yy_act = 1 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 70 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 70")
end
-- Ignore white space
else
	yy_column := yy_column + 3
--|#line 74 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 74")
end

							last_token := mime_tokens.FN_BCC
							to_condition := STRUCTURED_FIELD_BODY
							
end
else
if yy_act = 3 then
	yy_column := yy_column + 19
--|#line 82 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 82")
end

							last_token := mime_tokens.FN_CONTENT_DISPOSITION
							to_condition := MIME_FIELD_BODY
							
else
	yy_column := yy_column + 14
--|#line 86 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 86")
end

							last_token := mime_tokens.FN_CONTENT_LENGTH
							to_condition := MIME_FIELD_BODY
							
end
end
else
if yy_act <= 6 then
if yy_act = 5 then
	yy_column := yy_column + 25
--|#line 90 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 90")
end

							last_token := mime_tokens.FN_CONTENT_TRANSFER_ENCODING
							to_condition := MIME_FIELD_BODY
							
else
	yy_column := yy_column + 12
--|#line 94 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 94")
end

							last_token := mime_tokens.FN_CONTENT_TYPE
							to_condition := MIME_FIELD_BODY
							
end
else
	yy_column := yy_column + 4
--|#line 98 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 98")
end

							last_token := mime_tokens.FN_DATE
							to_condition := STRUCTURED_FIELD_BODY
							
end
end
else
if yy_act <= 11 then
if yy_act <= 9 then
if yy_act = 8 then
	yy_column := yy_column + 17
--|#line 106 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 106")
end

							last_token := mime_tokens.FN_IF_MODIFIED_SINCE
							to_condition := STRUCTURED_FIELD_BODY
							
else
	yy_column := yy_column + 10
--|#line 110 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 110")
end

							last_token := mime_tokens.FN_MESSAGE_ID
							to_condition := STRUCTURED_FIELD_BODY
							
end
else
if yy_act = 10 then
	yy_column := yy_column + 12
--|#line 114 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 114")
end

							last_token := mime_tokens.FN_VERSION
							-- I want to see two integers.
							-- tspecials from RFC 2045 include token, so I
							-- just get an atom if parsed according to that syntax.
							to_condition := STRUCTURED_FIELD_BODY
							
else
	yy_column := yy_column + 11
--|#line 127 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 127")
end

							last_token := mime_tokens.FN_RESENT_FROM
							to_condition := STRUCTURED_FIELD_BODY
							
end
end
else
if yy_act <= 13 then
if yy_act = 12 then
	yy_column := yy_column + 15
--|#line 131 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 131")
end

							last_token := mime_tokens.FN_RESENT_REPLY_TO
							to_condition := STRUCTURED_FIELD_BODY
							
else
	yy_column := yy_column + 13
--|#line 135 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 135")
end

							last_token := mime_tokens.FN_RESENT_SENDER
							to_condition := STRUCTURED_FIELD_BODY
							
end
else
	yy_column := yy_column + 11
--|#line 139 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 139")
end

							last_token := mime_tokens.FN_RETURN_PATH
							to_condition := STRUCTURED_FIELD_BODY
							
end
end
end
else
if yy_act <= 21 then
if yy_act <= 18 then
if yy_act <= 16 then
if yy_act = 15 then
	yy_column := yy_column + 6
--|#line 143 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 143")
end

							last_token := mime_tokens.FN_SENDER
							to_condition := STRUCTURED_FIELD_BODY
							
else
	yy_column := yy_column + 2
--|#line 147 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 147")
end

							last_token := mime_tokens.FN_TO
							to_condition := STRUCTURED_FIELD_BODY
							
end
else
if yy_act = 17 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 155 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 155")
end

							last_token := mime_tokens.FIELD_NAME
							last_value := to_canonical_field_name (text)
							to_condition := UNSTRUCTURED_FIELD_BODY
							
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 161 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 161")
end
 -- include space, so it's already skipped
							last_value := STRING_.make (64)
							last_token := Colon_code
							if to_condition /= 0 then
								set_start_condition (to_condition)
							end
							
end
end
else
if yy_act <= 20 then
if yy_act = 19 then
	yy_line := yy_line + 1
	yy_column := 1
--|#line 169 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 169")
end

							last_token := mime_tokens.CRLF
							
else
	yy_column := yy_column + 1
--|#line 177 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 177")
end

							set_start_condition (COMMENT)
							
end
else
	yy_column := yy_column + 1
--|#line 180 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 180")
end

							last_value := STRING_.make (32)
							set_start_condition (DOMAIN_LITERAL)
							
end
end
else
if yy_act <= 25 then
if yy_act <= 23 then
if yy_act = 22 then
	yy_column := yy_column + 1
--|#line 184 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 184")
end
 --"
							last_value := STRING_.make (32)
							set_start_condition (QUOTED_STRING)
							
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 188 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 188")
end
-- White space, ignore
end
else
if yy_act = 24 then
yy_set_column (1)
--|#line 189 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 189")
end
-- Folded-line white space, ignore
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 190 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 190")
end

							set_start_condition (INITIAL)
							to_condition := 0
							last_token := mime_tokens.CRLF
							
end
end
else
if yy_act <= 27 then
if yy_act = 26 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 195 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 195")
end
 --'
							last_token := mime_tokens.MIME_ATOM
							if encoded_word_scanner.is_encoded_word (text) then
								last_value := encoded_word_scanner.decode_word (text)
							else
								last_value := text
							end
							
else
	yy_column := yy_column + 1
--|#line 203 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 203")
end
 -- pass rest of stuff as is, perhaps exclude 8-bit chars??
							last_token := text.item (1).code
							
end
else
	yy_column := yy_column + 1
--|#line 211 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 211")
end

							set_start_condition (COMMENT)
							
end
end
end
end
else
if yy_act <= 42 then
if yy_act <= 35 then
if yy_act <= 32 then
if yy_act <= 30 then
if yy_act = 29 then
	yy_column := yy_column + 1
--|#line 214 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 214")
end

							last_value := STRING_.make (32)
							set_start_condition (DOMAIN_LITERAL)
							
else
	yy_column := yy_column + 1
--|#line 218 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 218")
end
 --"
							last_value := STRING_.make (32)
							set_start_condition (QUOTED_STRING)
							
end
else
if yy_act = 31 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 222 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 222")
end
-- White space, ignore
else
yy_set_column (1)
--|#line 223 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 223")
end
-- Folded-line white space, ignore
end
end
else
if yy_act <= 34 then
if yy_act = 33 then
	yy_line := yy_line + 1
	yy_column := 1
--|#line 224 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 224")
end

							set_start_condition (INITIAL)
							to_condition := 0
							last_token := mime_tokens.CRLF
							
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 229 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 229")
end
 --"
							last_token := mime_tokens.MIME_ATOM
							if encoded_word_scanner.is_encoded_word (text) then
								last_value := encoded_word_scanner.decode_word (text)
							else
								last_value := text
							end
							
end
else
	yy_column := yy_column + 1
--|#line 237 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 237")
end
 -- just return every other character
							last_token := text.item (1).code
							
end
end
else
if yy_act <= 39 then
if yy_act <= 37 then
if yy_act = 36 then
	yy_column := yy_column + 1
--|#line 241 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 241")
end
 last_token := Semicolon_code 
else
	yy_column := yy_column + 1
--|#line 242 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 242")
end
 last_token := Equal_code 
end
else
if yy_act = 38 then
	yy_column := yy_column + 1
--|#line 243 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 243")
end

							to_condition := PARAMETER
							set_start_condition (COMMENT)
							
else
	yy_column := yy_column + 1
--|#line 247 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 247")
end
 --"
							last_value := STRING_.make (32)
							to_condition := PARAMETER
							set_start_condition (QUOTED_STRING)
							
end
end
else
if yy_act <= 41 then
if yy_act = 40 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 252 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 252")
end
-- White space, ignore
else
yy_set_column (1)
--|#line 253 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 253")
end
-- Folded-line white space, ignore
end
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 254 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 254")
end

							set_start_condition (INITIAL)
							to_condition := 0
							last_token := mime_tokens.CRLF
							
end
end
end
else
if yy_act <= 49 then
if yy_act <= 46 then
if yy_act <= 44 then
if yy_act = 43 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 259 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 259")
end
 --"
							last_value := text
							last_token := mime_tokens.MIME_ATOM
							
else
	yy_column := yy_column + 1
--|#line 263 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 263")
end
 -- ignore all other stuff??
							last_token := text.item (1).code
							
end
else
if yy_act = 45 then
	yy_column := yy_column + 3
--|#line 272 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 272")
end
last_token := mime_tokens.KW_SUN
else
	yy_column := yy_column + 3
--|#line 273 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 273")
end
last_token := mime_tokens.KW_MON
end
end
else
if yy_act <= 48 then
if yy_act = 47 then
	yy_column := yy_column + 3
--|#line 274 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 274")
end
last_token := mime_tokens.KW_TUE
else
	yy_column := yy_column + 3
--|#line 275 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 275")
end
last_token := mime_tokens.KW_WED
end
else
	yy_column := yy_column + 3
--|#line 276 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 276")
end
last_token := mime_tokens.KW_THU
end
end
else
if yy_act <= 53 then
if yy_act <= 51 then
if yy_act = 50 then
	yy_column := yy_column + 3
--|#line 277 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 277")
end
last_token := mime_tokens.KW_FRI
else
	yy_column := yy_column + 3
--|#line 278 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 278")
end
last_token := mime_tokens.KW_SAT
end
else
if yy_act = 52 then
	yy_column := yy_column + 6
--|#line 279 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 279")
end
last_token := mime_tokens.KW_SUN
else
	yy_column := yy_column + 6
--|#line 280 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 280")
end
last_token := mime_tokens.KW_MON
end
end
else
if yy_act <= 55 then
if yy_act = 54 then
	yy_column := yy_column + 7
--|#line 281 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 281")
end
last_token := mime_tokens.KW_TUE
else
	yy_column := yy_column + 9
--|#line 282 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 282")
end
last_token := mime_tokens.KW_WED
end
else
	yy_column := yy_column + 8
--|#line 283 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 283")
end
last_token := mime_tokens.KW_THU
end
end
end
end
end
else
if yy_act <= 84 then
if yy_act <= 70 then
if yy_act <= 63 then
if yy_act <= 60 then
if yy_act <= 58 then
if yy_act = 57 then
	yy_column := yy_column + 6
--|#line 284 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 284")
end
last_token := mime_tokens.KW_FRI
else
	yy_column := yy_column + 8
--|#line 285 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 285")
end
last_token := mime_tokens.KW_SAT
end
else
if yy_act = 59 then
	yy_column := yy_column + 3
--|#line 286 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 286")
end
last_token := mime_tokens.MONTH; set_last_integer (1)
else
	yy_column := yy_column + 3
--|#line 287 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 287")
end
last_token := mime_tokens.MONTH; set_last_integer (2)
end
end
else
if yy_act <= 62 then
if yy_act = 61 then
	yy_column := yy_column + 3
--|#line 288 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 288")
end
last_token := mime_tokens.MONTH; set_last_integer (3)
else
	yy_column := yy_column + 3
--|#line 289 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 289")
end
last_token := mime_tokens.MONTH; set_last_integer (4)
end
else
	yy_column := yy_column + 3
--|#line 290 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 290")
end
last_token := mime_tokens.MONTH; set_last_integer (5)
end
end
else
if yy_act <= 67 then
if yy_act <= 65 then
if yy_act = 64 then
	yy_column := yy_column + 3
--|#line 291 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 291")
end
last_token := mime_tokens.MONTH; set_last_integer (6)
else
	yy_column := yy_column + 3
--|#line 292 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 292")
end
last_token := mime_tokens.MONTH; set_last_integer (7)
end
else
if yy_act = 66 then
	yy_column := yy_column + 3
--|#line 293 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 293")
end
last_token := mime_tokens.MONTH; set_last_integer (8)
else
	yy_column := yy_column + 3
--|#line 294 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 294")
end
last_token := mime_tokens.MONTH; set_last_integer (9)
end
end
else
if yy_act <= 69 then
if yy_act = 68 then
	yy_column := yy_column + 3
--|#line 295 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 295")
end
last_token := mime_tokens.MONTH; set_last_integer (10)
else
	yy_column := yy_column + 3
--|#line 296 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 296")
end
last_token := mime_tokens.MONTH; set_last_integer (11)
end
else
	yy_column := yy_column + 3
--|#line 297 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 297")
end
last_token := mime_tokens.MONTH; set_last_integer (12)
end
end
end
else
if yy_act <= 77 then
if yy_act <= 74 then
if yy_act <= 72 then
if yy_act = 71 then
	yy_column := yy_column + 3
--|#line 298 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 298")
end
last_token := mime_tokens.NUMBER; set_last_integer (0)
else
	yy_column := yy_column + 2
--|#line 299 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 299")
end
last_token := mime_tokens.NUMBER; set_last_integer (0)
end
else
if yy_act = 73 then
	yy_column := yy_column + 3
--|#line 300 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 300")
end
last_token := mime_tokens.NUMBER; set_last_integer (-5)
else
	yy_column := yy_column + 3
--|#line 301 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 301")
end
last_token := mime_tokens.NUMBER; set_last_integer (-4)
end
end
else
if yy_act <= 76 then
if yy_act = 75 then
	yy_column := yy_column + 3
--|#line 302 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 302")
end
last_token := mime_tokens.NUMBER; set_last_integer (-6)
else
	yy_column := yy_column + 3
--|#line 303 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 303")
end
last_token := mime_tokens.NUMBER; set_last_integer (-5)
end
else
	yy_column := yy_column + 3
--|#line 304 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 304")
end
last_token := mime_tokens.NUMBER; set_last_integer (-7)
end
end
else
if yy_act <= 81 then
if yy_act <= 79 then
if yy_act = 78 then
	yy_column := yy_column + 3
--|#line 305 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 305")
end
last_token := mime_tokens.NUMBER; set_last_integer (-6)
else
	yy_column := yy_column + 3
--|#line 306 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 306")
end
last_token := mime_tokens.NUMBER; set_last_integer (-8)
end
else
if yy_act = 80 then
	yy_column := yy_column + 3
--|#line 307 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 307")
end
last_token := mime_tokens.NUMBER; set_last_integer (-7)
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 308 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 308")
end
 -- parse these time zones, but ignore them
						  last_token := mime_tokens.NUMBER; last_value := text; set_last_integer (0)
						  
end
end
else
if yy_act <= 83 then
if yy_act = 82 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 311 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 311")
end
 -- finally, parse the shit spammers spew out like time zone XXXXXXXXXXXX
						  last_token := mime_tokens.NUMBER; last_value := text; set_last_integer (0)
						  
else
	yy_column := yy_column + 1
--|#line 314 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 314")
end
last_token := Comma_code
end
else
	yy_column := yy_column + 1
--|#line 315 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 315")
end
last_token := Colon_code
end
end
end
end
else
if yy_act <= 98 then
if yy_act <= 91 then
if yy_act <= 88 then
if yy_act <= 86 then
if yy_act = 85 then
	yy_column := yy_column + 1
--|#line 316 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 316")
end
last_token := Minus_code
else
	yy_column := yy_column + 1
--|#line 317 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 317")
end

						  last_token := Semicolon_code
						  set_start_condition (STRUCTURED_FIELD_BODY)
						  
end
else
if yy_act = 87 then
	yy_column := yy_column + 1
--|#line 321 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 321")
end
 -- " we use this to recognize some s**t
						  last_token := Double_quote_code
						  
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 324 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 324")
end
-- (Folded-line) white space, ignore
end
end
else
if yy_act <= 90 then
if yy_act = 89 then
yy_set_column (1)
--|#line 325 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 325")
end
-- (Folded-line) white space, ignore
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 326 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 326")
end

						  set_last_integer (text.to_integer)
						  last_token := mime_tokens.NUMBER
						  
end
else
	yy_column := yy_column + 1
--|#line 330 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 330")
end

						  to_condition := DATE
						  set_start_condition (COMMENT)
						  
end
end
else
if yy_act <= 95 then
if yy_act <= 93 then
if yy_act = 92 then
	yy_line := yy_line + 1
	yy_column := 1
--|#line 334 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 334")
end

						  set_start_condition (INITIAL)
						  to_condition := 0
						  last_token := mime_tokens.CRLF
						  
else
	yy_column := yy_column + 2
--|#line 343 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 343")
end
 
end
else
if yy_act = 94 then
	yy_column := yy_column + 2
--|#line 344 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 344")
end
 
else
	yy_column := yy_column + 1
--|#line 345 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 345")
end

							if nested_comment_count = 0 then
								set_start_condition (to_condition)
							else
								nested_comment_count := nested_comment_count - 1
							end
							
end
end
else
if yy_act <= 97 then
if yy_act = 96 then
	yy_column := yy_column + 1
--|#line 352 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 352")
end
 nested_comment_count := nested_comment_count + 1 
else
yy_set_line_column
--|#line 353 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 353")
end
 
end
else
	yy_column := yy_column + 2
--|#line 359 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 359")
end
 last_string.append_character (text.item (2)) 
end
end
end
else
if yy_act <= 105 then
if yy_act <= 102 then
if yy_act <= 100 then
if yy_act = 99 then
	yy_column := yy_column + 1
--|#line 360 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 360")
end

							set_start_condition (to_condition)
							last_token := mime_tokens.DOMAIN_LITERAL
							
else
yy_set_column (1)
--|#line 364 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 364")
end

							last_string.append_character (' ')
							
end
else
if yy_act = 101 then
yy_set_line_column
--|#line 367 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 367")
end
 last_string.append_string (text) 
else
	yy_column := yy_column + 2
--|#line 372 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 372")
end
 last_string.append_character (text.item (2)) 
end
end
else
if yy_act <= 104 then
if yy_act = 103 then
	yy_column := yy_column + 1
--|#line 373 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 373")
end
 --"
							set_start_condition (to_condition)
							last_token := mime_tokens.QUOTED_STRING
							
else
yy_set_column (1)
--|#line 377 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 377")
end

							last_string.append_character (' ')
							
end
else
yy_set_line_column
--|#line 380 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 380")
end
 --"
							last_string.append_string (text)
							
end
end
else
if yy_act <= 109 then
if yy_act <= 107 then
if yy_act = 106 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 387 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 387")
end

							if encoded_word_scanner.is_encoded_word (text) then
								if prev_word_was_encoded then
									from
									until
										last_string.is_empty or else
										(last_string.item (last_string.count) /= ' ' and then
										last_string.item (last_string.count) /= '%T')
									loop
										last_string.keep_head (last_string.count - 1)
									end
								end
								last_string.append_string (encoded_word_scanner.decode_word (text))
								prev_word_was_encoded := True
							else
								last_string.append_string (text)
								prev_word_was_encoded := False
							end
							
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 406 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 406")
end
last_string.append_string (text)
end
else
if yy_act = 108 then
yy_set_column (1)
--|#line 407 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 407")
end
 -- Folded line
							last_string.append_character (' ')
							
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 410 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 410")
end

							if last_string.is_empty then
								last_token := mime_tokens.CRLF
							else
								less (0)
								last_token := mime_tokens.FIELD_BODY
							end
							to_condition := 0
							set_start_condition (INITIAL)
							prev_word_was_encoded := False
							
end
end
else
if yy_act <= 111 then
if yy_act = 110 then
	yy_column := yy_column + 1
--|#line 421 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 421")
end
-- ignore lone CR's
else
	yy_column := yy_column + 1
--|#line 427 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 427")
end
-- ignore all other charcters, i.e. ascii unprintables and high ascii
end
else
yy_set_line_column
--|#line 0 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 0")
end
last_token := yyError_token
fatal_error ("scanner jammed")
end
end
end
end
end
end
		end

	yy_execute_eof_action (yy_sc: INTEGER) is
			-- Execute EOF semantic action.
		do
			inspect yy_sc
when 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 then
--|#line 0 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 0")
end
 terminate 
			else
				terminate
			end
		end

feature {NONE} -- Table templates

	yy_nxt_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,   22,   23,   24,   25,   26,   38,   39,   40,   38,
			   38,   39,   40,   38,  358,  358,   28,   67,   68,   67,
			   68,  358,  140,  141,   29,   30,   31,   71,   72,  109,
			  358,   32,  109,   71,   72,   33,  116,  114,  358,   34,
			   35,   36,   77,   78,   77,   78,   79,  117,   79,  358,
			   22,   22,   23,   24,   25,   26,   69,  109,   69,  113,
			  111,  124,  113,  118,  124,  115,   28,  119,  358,  358,
			  125,   73,   74,  125,   29,   30,   31,   73,   74,  127,
			  128,   32,  127,  128,  122,   33,   80,  142,   80,   34,
			   35,   36,  131,  120,  121,  131,  132,  162,  358,  132,

			   22,   41,   42,   43,   44,   42,  147,   46,   47,   41,
			  151,   41,  135,   41,  175,  135,   41,   41,   41,  159,
			   41,  136,   41,  143,  136,  148,  143,  152,  148,  157,
			  152,  153,  146,  158,  153,  167,  183,  187,  159,  213,
			  159,  358,  160,  168,  159,  159,   48,   41,   41,  159,
			   41,   41,   42,   43,   44,   42,  161,   46,   47,   41,
			  163,   41,  169,   41,  165,  159,   41,   41,   41,  159,
			   41,  184,   41,  174,  164,  181,  166,  109,  109,  113,
			  109,  111,  113,  159,  325,  159,  159,  182,  358,  358,
			  358,  358,  176,  159,  159,  358,   48,   41,   41,  358,

			   41,   49,   50,   51,   52,   50,  177,   54,   55,   49,
			  170,   49,  185,  171,   49,  159,   49,   49,   49,   49,
			   49,   49,   49,  358,  172,  186,  189,  173,  190,  358,
			  229,  124,  358,  188,  124,  178,  159,  191,  192,  179,
			  125,  125,  127,  125,  125,  127,   56,   49,   49,   49,
			   50,   51,   52,   50,  180,   54,   55,   49,  358,   49,
			  318,  159,   49,  193,   49,   49,   49,   49,   49,   49,
			   49,  128,  128,  131,  128,  128,  131,  132,  132,  135,
			  132,  132,  135,  136,  136,  143,  136,  136,  143,  143,
			  148,  225,  143,  148,   56,   49,   49,   57,   58,   59,

			   60,   58,  199,   62,   63,   57,  148,   57,  152,  148,
			   57,  152,   57,   64,   57,   65,   57,   57,   57,  153,
			  153,  195,  153,  153,  197,  198,  159,  200,  201,  202,
			  196,  159,  159,  159,  220,  159,  159,  358,  203,  194,
			  159,  159,   57,   57,   57,   57,   58,   59,   60,   58,
			  159,   62,   63,   57,  159,   57,  159,  205,   57,  204,
			   57,   64,   57,   65,   57,   57,   57,  159,  208,  206,
			  159,  207,  210,  211,  209,  212,  223,  214,  159,  215,
			  159,  216,  156,  159,  159,  159,  159,  159,  358,  159,
			   57,   57,   57,   75,   81,   82,   83,   81,   75,   84,

			   85,   75,   86,   87,   88,   75,   75,   89,   90,   91,
			   75,   75,   75,   75,   75,   92,   93,   94,   95,   96,
			   97,   98,   93,   93,   99,   93,   93,  100,  101,  102,
			  103,   93,  104,  105,  106,   93,  107,   93,   75,   75,
			   75,  108,   75,  217,  218,  219,  221,  222,  358,  358,
			  358,  159,  358,  358,  358,  159,  358,  358,  159,  358,
			  358,  358,  358,  358,  358,  358,  358,  241,  159,  358,
			  159,  358,  358,  224,  358,  227,  358,  228,  230,  358,
			  240,  238,  358,  358,  358,  358,  358,  226,  239,  244,
			  253,  358,  254,  270,  242,  358,  252,  358,  243,  358,

			  358,  268,  358,  358,  255,  257,  358,  271,  256,  258,
			  269,  267,  276,  266,  358,  283,  278,  277,  358,  287,
			  358,  279,  358,  358,  292,  280,  358,  288,  358,  290,
			  358,  358,  291,  358,  289,  358,  281,  282,  358,  358,
			  358,  358,  358,  294,  296,  295,  358,  299,  358,  358,
			  358,  293,  358,  358,  303,  298,  302,  358,  358,  358,
			  358,  358,  304,  358,  358,  300,  358,  311,  358,  358,
			  305,  301,  358,  307,  306,  310,  313,  317,  323,  308,
			  309,  358,  315,  358,  312,  314,  320,  358,  322,  316,
			  358,  326,  358,  331,  319,  321,  358,  358,  324,  328,

			  358,  358,  358,  358,  327,  358,  358,  358,  358,  358,
			  329,  358,  358,  358,  358,  358,  358,  358,  358,  330,
			  334,  346,  335,  358,  332,  358,  336,  339,  333,  358,
			  338,  344,  358,  358,  358,  358,  352,  340,  345,  337,
			  341,  347,  349,  358,  343,  342,  358,  348,  350,  351,
			  358,  358,  355,  353,  358,  358,  354,  358,  297,  356,
			  357,   27,   27,   27,   27,   27,   27,   27,   27,   27,
			   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
			   27,   37,   37,   37,   37,   37,   37,   37,   37,   37,
			   37,   37,   37,   37,   37,   37,   37,   37,   37,   37,

			   37,   45,   45,   45,   45,   45,   45,   45,   45,   45,
			   45,   45,   45,   45,   45,   45,   45,   45,   45,   45,
			   45,   53,   53,   53,   53,   53,   53,   53,   53,   53,
			   53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
			   53,   61,   61,   61,   61,   61,   61,   61,   61,   61,
			   61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
			   61,   66,   66,   66,   66,   66,   66,   66,   66,   66,
			   66,   66,   66,   66,   66,   66,   66,   66,   66,   66,
			   66,   70,   70,   70,   70,   70,   70,   70,   70,   70,
			   70,   70,   70,   70,   70,   70,   70,   70,   70,   70,

			   70,   75,   75,   75,   75,   75,   75,   75,   75,   75,
			   75,   75,   75,   75,   75,   75,   75,   75,   75,   75,
			   75,   76,   76,   76,   76,   76,   76,   76,   76,   76,
			   76,   76,   76,   76,   76,   76,   76,   76,   76,   76,
			   76,  112,  286,  112,  112,  112,  112,  112,  112,  112,
			  112,  112,  112,  112,  112,  112,  112,  112,  112,  123,
			  285,  284,  123,  123,  123,  123,  123,  123,  123,  123,
			  123,  123,  123,  123,  123,  123,  123,  123,  123,  130,
			  275,  274,  273,  272,  130,  358,  130,  130,  130,  130,
			  134,  130,  265,  264,  263,  134,  134,  262,  134,  138,

			  261,  260,  134,  259,  138,  138,  134,  138,  251,  250,
			  249,  138,  248,  247,  246,  138,  139,  139,  139,  139,
			  139,  245,  358,  139,  139,  139,  139,  139,  139,  139,
			  139,  139,  139,  139,  139,  139,  142,  142,  142,  142,
			  142,  142,  142,  142,  142,  142,  142,  142,  142,  142,
			  142,  142,  142,  142,  237,  142,  145,  145,  145,  145,
			  145,  145,  145,  145,  145,  145,  145,  145,  145,  145,
			  145,  145,  145,  145,  145,  145,  147,  147,  147,  147,
			  236,  147,  147,  147,  147,  147,  147,  147,  147,  147,
			  147,  147,  147,  147,  147,  147,  150,  150,  150,  150,

			  150,  150,  150,  150,  150,  150,  150,  150,  150,  150,
			  150,  150,  150,  150,  150,  150,  235,  234,  233,  232,
			  231,  358,  159,  159,  155,  358,  358,  159,  155,  155,
			  155,  154,  149,  144,  137,  133,  129,  126,  358,  110,
			  358,   21,  358,  358,  358,  358,  358,  358,  358,  358,
			  358,  358,  358,  358,  358,  358,  358,  358,  358,  358,
			  358,  358,  358,  358,  358,  358,  358,  358,  358,  358,
			  358,  358,  358,  358,  358,  358,  358,  358,  358,  358,
			  358,  358,  358,  358,  358,  358,  358,  358,  358,  358,
			  358,  358>>)
		end

	yy_chk_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,    3,    3,    3,    3,
			    4,    4,    4,    4,   29,   31,    1,   11,   11,   12,
			   12,   32,   69,   69,    1,    1,    1,   13,   13,   23,
			   30,    1,   23,   14,   14,    1,   31,   29,   33,    1,
			    1,    1,   17,   17,   18,   18,   17,   32,   18,   36,
			    1,    2,    2,    2,    2,    2,   11,   26,   12,   28,
			   26,   38,   28,   33,   38,   30,    2,   33,   34,   35,
			   39,   13,   13,   39,    2,    2,    2,   14,   14,   42,
			   43,    2,   42,   43,   36,    2,   17,   73,   18,    2,
			    2,    2,   50,   34,   35,   50,   51,   95,  116,   51,

			    2,    5,    5,    5,    5,    5,   80,    5,    5,    5,
			   80,    5,   58,    5,  102,   58,    5,    5,    5,   95,
			    5,   59,    5,   71,   59,   77,   71,   81,   77,   92,
			   81,   82,   73,   92,   82,   98,  106,  116,  102,  174,
			   92,  316,   94,   99,  106,  174,    5,    5,    5,   98,
			    5,    6,    6,    6,    6,    6,   94,    6,    6,    6,
			   96,    6,   99,    6,   97,   94,    6,    6,    6,   99,
			    6,  107,    6,  101,   96,  105,   97,  109,  111,  113,
			  109,  111,  113,   96,  316,  101,   97,  105,  118,  114,
			  192,  115,  103,  107,  105,  119,    6,    6,    6,  120,

			    6,    7,    7,    7,    7,    7,  103,    7,    7,    7,
			  100,    7,  114,  100,    7,  103,    7,    7,    7,    7,
			    7,    7,    7,  117,  100,  115,  118,  100,  119,  121,
			  192,  124,  308,  117,  124,  104,  100,  120,  120,  104,
			  125,  126,  127,  125,  126,  127,    7,    7,    7,    8,
			    8,    8,    8,    8,  104,    8,    8,    8,  188,    8,
			  308,  104,    8,  121,    8,    8,    8,    8,    8,    8,
			    8,  128,  129,  131,  128,  129,  131,  132,  133,  135,
			  132,  133,  135,  136,  137,  143,  136,  137,  143,  144,
			  148,  188,  144,  148,    8,    8,    8,    9,    9,    9,

			    9,    9,  162,    9,    9,    9,  149,    9,  152,  149,
			    9,  152,    9,    9,    9,    9,    9,    9,    9,  153,
			  154,  157,  153,  154,  160,  161,  162,  163,  164,  165,
			  158,  157,  160,  161,  181,  163,  164,  186,  166,  380,
			  379,  181,    9,    9,    9,   10,   10,   10,   10,   10,
			  158,   10,   10,   10,  165,   10,  166,  168,   10,  167,
			   10,   10,   10,   10,   10,   10,   10,  167,  170,  169,
			  168,  169,  171,  172,  170,  173,  186,  175,  170,  176,
			  171,  177,  378,  173,  169,  175,  172,  176,  357,  177,
			   10,   10,   10,   19,   19,   19,   19,   19,   19,   19,

			   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
			   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
			   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
			   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
			   19,   19,   19,  178,  179,  180,  182,  184,  187,  189,
			  190,  178,  191,  225,  193,  179,  223,  227,  180,  226,
			  228,  229,  238,  241,  230,  240,  239,  227,  182,  242,
			  184,  243,  244,  187,  252,  190,  254,  191,  193,  271,
			  226,  223,  253,  256,  269,  255,  279,  189,  225,  230,
			  239,  267,  240,  256,  228,  276,  238,  257,  229,  270,

			  277,  254,  266,  278,  241,  243,  268,  257,  242,  244,
			  255,  253,  266,  252,  280,  271,  268,  267,  281,  276,
			  282,  269,  288,  283,  279,  270,  287,  276,  289,  277,
			  291,  290,  278,  292,  276,  293,  270,  270,  294,  295,
			  296,  299,  298,  281,  283,  282,  300,  288,  301,  305,
			  304,  280,  302,  307,  291,  287,  290,  306,  309,  310,
			  320,  311,  292,  312,  314,  289,  317,  300,  313,  319,
			  293,  289,  321,  295,  294,  299,  302,  307,  313,  296,
			  298,  323,  305,  325,  301,  304,  310,  326,  312,  306,
			  327,  317,  328,  325,  309,  311,  329,  330,  314,  320,

			  331,  333,  335,  336,  319,  337,  338,  339,  340,  342,
			  321,  343,  345,  351,  348,  349,  344,  346,  352,  323,
			  328,  343,  329,  354,  326,  355,  330,  335,  327,  350,
			  333,  340,  353,  356,  347,  341,  351,  336,  342,  331,
			  337,  344,  346,  334,  339,  338,  332,  345,  348,  349,
			  324,  322,  354,  352,  318,  315,  353,  303,  286,  355,
			  356,  359,  359,  359,  359,  359,  359,  359,  359,  359,
			  359,  359,  359,  359,  359,  359,  359,  359,  359,  359,
			  359,  360,  360,  360,  360,  360,  360,  360,  360,  360,
			  360,  360,  360,  360,  360,  360,  360,  360,  360,  360,

			  360,  361,  361,  361,  361,  361,  361,  361,  361,  361,
			  361,  361,  361,  361,  361,  361,  361,  361,  361,  361,
			  361,  362,  362,  362,  362,  362,  362,  362,  362,  362,
			  362,  362,  362,  362,  362,  362,  362,  362,  362,  362,
			  362,  363,  363,  363,  363,  363,  363,  363,  363,  363,
			  363,  363,  363,  363,  363,  363,  363,  363,  363,  363,
			  363,  364,  364,  364,  364,  364,  364,  364,  364,  364,
			  364,  364,  364,  364,  364,  364,  364,  364,  364,  364,
			  364,  365,  365,  365,  365,  365,  365,  365,  365,  365,
			  365,  365,  365,  365,  365,  365,  365,  365,  365,  365,

			  365,  366,  366,  366,  366,  366,  366,  366,  366,  366,
			  366,  366,  366,  366,  366,  366,  366,  366,  366,  366,
			  366,  367,  367,  367,  367,  367,  367,  367,  367,  367,
			  367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
			  367,  368,  275,  368,  368,  368,  368,  368,  368,  368,
			  368,  368,  368,  368,  368,  368,  368,  368,  368,  369,
			  273,  272,  369,  369,  369,  369,  369,  369,  369,  369,
			  369,  369,  369,  369,  369,  369,  369,  369,  369,  370,
			  265,  264,  263,  261,  370,  258,  370,  370,  370,  370,
			  371,  370,  251,  250,  249,  371,  371,  248,  371,  372,

			  247,  246,  371,  245,  372,  372,  371,  372,  237,  236,
			  235,  372,  234,  233,  232,  372,  373,  373,  373,  373,
			  373,  231,  224,  373,  373,  373,  373,  373,  373,  373,
			  373,  373,  373,  373,  373,  373,  374,  374,  374,  374,
			  374,  374,  374,  374,  374,  374,  374,  374,  374,  374,
			  374,  374,  374,  374,  222,  374,  375,  375,  375,  375,
			  375,  375,  375,  375,  375,  375,  375,  375,  375,  375,
			  375,  375,  375,  375,  375,  375,  376,  376,  376,  376,
			  221,  376,  376,  376,  376,  376,  376,  376,  376,  376,
			  376,  376,  376,  376,  376,  376,  377,  377,  377,  377,

			  377,  377,  377,  377,  377,  377,  377,  377,  377,  377,
			  377,  377,  377,  377,  377,  377,  220,  219,  217,  211,
			  203,  185,  183,  156,  155,  122,  112,   93,   89,   88,
			   86,   83,   78,   72,   60,   52,   44,   40,   27,   25,
			   21,  358,  358,  358,  358,  358,  358,  358,  358,  358,
			  358,  358,  358,  358,  358,  358,  358,  358,  358,  358,
			  358,  358,  358,  358,  358,  358,  358,  358,  358,  358,
			  358,  358,  358,  358,  358,  358,  358,  358,  358,  358,
			  358,  358,  358,  358,  358,  358,  358,  358,  358,  358,
			  358,  358>>)
		end

	yy_base_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    0,   50,    4,    8,  100,  150,  200,  248,  296,
			  344,    9,   11,   24,   30,    0,    0,   39,   41,  392,
			    0, 1040, 1041,   27, 1041, 1036,   55, 1036,   57,   12,
			   28,   13,   19,   36,   66,   67,   47,    0,   59,   68,
			 1034, 1041,   77,   78, 1033,    0, 1041, 1041, 1041, 1041,
			   90,   94, 1032,    0, 1041, 1041, 1041, 1041,  110,  119,
			 1031,    0, 1041, 1041, 1041, 1041,    0, 1041, 1041,   14,
			    0,  121, 1030,   84, 1041, 1041,    0,  123, 1029, 1041,
			  103,  125,  129, 1028, 1041, 1041, 1015, 1041, 1014, 1013,
			 1041, 1041,   91,  978,  116,   70,  134,  137,  100,  120,

			  187,  136,   89,  166,  212,  145,   95,  144,    0,  175,
			 1041,  176, 1024,  177,  187,  189,   96,  221,  186,  193,
			  197,  227, 1023,    0,  229,  238,  239,  240,  269,  270,
			    0,  271,  275,  276,    0,  277,  281,  282,    0,    0,
			 1041, 1041,    0,  283,  287,    0, 1041,    0,  288,  304,
			    0, 1041,  306,  317,  318, 1009,  974,  282,  301,    0,
			  283,  284,  277,  286,  287,  305,  307,  318,  321,  335,
			  329,  331,  337,  334,   96,  336,  338,  340,  402,  406,
			  409,  292,  419,  973,  421, 1019,  335,  446,  256,  447,
			  448,  450,  188,  452,    0,    0,    0,    0,    0,    0,

			    0,    0,    0,  994,    0,    0,    0,    0,    0,    0,
			    0,  993,    0,    0,    0,    0,    0,  976,    0,  991,
			  977,  940,  918,  454,  920,  451,  457,  455,  458,  459,
			  462,  898,  891,  874,  889,  870,  883,  881,  460,  464,
			  463,  461,  467,  469,  470,  858,  856,  874,  852,  868,
			  870,  852,  472,  480,  474,  483,  481,  495,  883,    0,
			    0,  860,    0,  859,  836,  854,  500,  489,  504,  482,
			  497,  477,  816,  815,    0,  819,  493,  498,  501,  484,
			  512,  516,  518,  521,    0,    0,  613,  524,  520,  526,
			  529,  528,  531,  533,  536,  537,  538,    0,  540,  539,

			  544,  546,  550,  655,  548,  547,  555,  551,  230,  556,
			  557,  559,  561,  566,  562,  653,  139,  564,  652,  567,
			  558,  570,  649,  579,  648,  581,  585,  588,  590,  594,
			  595,  598,  644,  599,  641,  600,  601,  603,  604,  605,
			  606,  633,  607,  609,  614,  610,  615,  632,  612,  613,
			  627,  611,  616,  630,  621,  623,  631,  386, 1041,  660,
			  680,  700,  720,  740,  760,  780,  800,  820,  839,  858,
			  875,  886,  895,  915,  935,  955,  975,  995,  366,  324,
			  323>>)
		end

	yy_def_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,  359,  359,  360,  360,  361,  361,  362,  362,  363,
			  363,  364,  364,  365,  365,  366,  366,  367,  367,  358,
			   19,  358,  358,  358,  358,  358,  368,  368,  358,  368,
			  368,  368,  368,  368,  368,  368,  368,  369,  358,  358,
			  358,  358,  358,  358,  358,  370,  358,  358,  358,  358,
			  358,  358,  358,  371,  358,  358,  358,  358,  358,  358,
			  358,  372,  358,  358,  358,  358,  373,  358,  358,  373,
			  374,  374,  374,  375,  358,  358,  376,  376,  376,  358,
			  377,  358,  358,  358,  358,  358,  358,  358,  358,  358,
			  358,  358,  378,  378,  378,  378,  378,  378,  378,  378,

			  378,  378,  378,  378,  378,  378,  378,  378,  379,  358,
			  358,  368,  368,  358,  368,  368,  368,  368,  368,  368,
			  368,  368,  368,  369,  358,  358,  358,  358,  358,  358,
			  370,  358,  358,  358,  371,  358,  358,  358,  372,  373,
			  358,  358,  374,  374,  374,  374,  358,  376,  376,  376,
			  376,  358,  358,  358,  358,  358,  380,  380,  380,  379,
			  380,  380,  380,  380,  380,  380,  380,  380,  380,  380,
			  380,  380,  380,  380,  380,  380,  380,  380,  380,  380,
			  380,  380,  380,  380,  380,  368,  368,  368,  368,  368,
			  368,  368,  368,  368,  379,  379,  379,  379,  379,  379,

			  379,  379,  379,  379,  379,  379,  379,  379,  379,  379,
			  379,  379,  379,  379,  379,  379,  379,  379,  379,  379,
			  379,  379,  379,  368,  368,  368,  368,  368,  368,  368,
			  368,  379,  379,  379,  379,  379,  379,  379,  368,  368,
			  368,  368,  368,  368,  368,  379,  379,  379,  379,  379,
			  379,  379,  368,  368,  368,  368,  368,  368,  368,  379,
			  379,  379,  379,  379,  379,  379,  368,  368,  368,  368,
			  368,  368,  379,  379,  379,  379,  368,  368,  368,  368,
			  368,  368,  368,  368,  379,  379,  379,  368,  368,  368,
			  368,  368,  368,  368,  368,  368,  368,  379,  368,  368,

			  368,  368,  368,  368,  368,  368,  368,  368,  368,  368,
			  368,  368,  368,  368,  368,  368,  368,  368,  368,  368,
			  368,  368,  368,  368,  368,  368,  368,  368,  368,  368,
			  368,  368,  368,  368,  368,  368,  368,  368,  368,  368,
			  368,  368,  368,  368,  368,  368,  368,  368,  368,  368,
			  368,  368,  368,  368,  368,  368,  368,  368,    0,  358,
			  358,  358,  358,  358,  358,  358,  358,  358,  358,  358,
			  358,  358,  358,  358,  358,  358,  358,  358,  358,  358,
			  358>>)
		end

	yy_ec_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,    1,    1,    1,    2,
			    3,    1,    1,    4,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    5,    6,    7,    6,    6,    6,    6,    6,
			    8,    9,    6,   10,   11,   12,   13,   14,   15,   15,
			   15,   15,   15,   15,   15,   15,   15,   15,   16,   17,
			   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,
			   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,
			   38,   33,   39,   40,   41,   42,   43,   44,   33,   45,
			   33,   46,   47,   48,    6,   49,    6,   23,   24,   25,

			   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
			   36,   37,   38,   33,   39,   40,   41,   42,   43,   44,
			   33,   45,   33,    6,    6,    6,    6,   50,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1>>)
		end

	yy_meta_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    1,    2,    3,    3,    2,    4,    5,    6,    7,
			    4,    8,    9,   10,   11,   12,    1,    8,    8,   13,
			    8,   14,   15,   16,   16,   16,   16,   16,   16,   16,
			   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,
			   16,   16,   16,   16,   16,   16,   17,   18,   19,   16,
			   20>>)
		end

	yy_accept_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,  113,  111,    1,   19,  111,    1,   17,   18,   17,
			   17,   17,   17,   17,   17,   17,   17,  106,  107,  109,
			  110,   27,   23,   25,   27,   26,   22,   20,   21,   35,
			   31,   33,   35,   34,   30,   28,   29,   44,   40,   42,
			   44,   43,   39,   38,   36,   37,   97,   96,   95,   97,
			  101,  101,  101,  101,   99,  112,  105,  105,  105,  103,
			  105,   88,   92,  112,   87,   91,  112,   83,   85,   90,
			   84,   86,   81,   81,   81,   81,   81,   81,   81,   81,

			   81,   81,   81,   81,   81,   81,   81,   81,   82,    1,
			   19,    1,   17,   18,   17,   17,   17,   17,   17,   17,
			   17,   17,   16,  106,  107,  108,  109,   23,   24,   25,
			   26,   31,   32,   33,   34,   40,   41,   42,   43,   97,
			   93,   94,  101,  100,  101,   98,   98,  105,  104,  105,
			  102,  102,   88,   89,   92,   90,   81,   81,   81,   82,
			   81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
			   81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
			   81,   81,   81,   72,   81,    2,   17,   17,   17,   17,
			   17,   17,   17,   17,   81,   62,   66,   76,   75,   70,

			   74,   73,   60,   50,   71,   59,   65,   64,   61,   63,
			   78,   46,   77,   69,   68,   80,   79,   51,   67,   45,
			   49,   47,   48,   17,    7,   17,   17,   17,   17,   17,
			   17,   82,   82,   82,   82,   82,   82,   82,   17,   17,
			   17,   17,   17,   17,   17,   82,   82,   82,   82,   82,
			   82,   82,   17,   17,   17,   17,   17,   17,   15,   57,
			   53,   82,   52,   82,   82,   82,   17,   17,   17,   17,
			   17,   17,   82,   82,   54,   82,   17,   17,   17,   17,
			   17,   17,   17,   17,   58,   56,   82,   17,   17,   17,
			   17,   17,   17,   17,   17,   17,   17,   55,   17,   17,

			   17,   17,   17,    9,   17,   17,   17,   17,   17,   17,
			   17,   17,   17,   17,   17,   11,   17,   17,   14,   17,
			   17,   17,    6,   17,   10,   17,   17,   17,   17,   17,
			   17,   17,   13,   17,    4,   17,   17,   17,   17,   17,
			   17,   12,   17,   17,   17,   17,   17,    8,   17,   17,
			    3,   17,   17,   17,   17,   17,   17,    5,    0>>)
		end

feature {NONE} -- Constants

	yyJam_base: INTEGER is 1041
			-- Position in `yy_nxt'/`yy_chk' tables
			-- where default jam table starts

	yyJam_state: INTEGER is 358
			-- State id corresponding to jam state

	yyTemplate_mark: INTEGER is 359
			-- Mark between normal states and templates

	yyNull_equiv_class: INTEGER is 1
			-- Equivalence code for NULL character

	yyReject_used: BOOLEAN is false
			-- Is `reject' called?

	yyVariable_trail_context: BOOLEAN is false
			-- Is there a regular expression with
			-- both leading and trailing parts having
			-- variable length?

	yyReject_or_variable_trail_context: BOOLEAN is false
			-- Is `reject' called or is there a
			-- regular expression with both leading
			-- and trailing parts having variable length?

	yyNb_rules: INTEGER is 112
			-- Number of rules

	yyEnd_of_buffer: INTEGER is 113
			-- End of buffer rule code

	yyLine_used: BOOLEAN is true
			-- Are line and column numbers used?

	yyPosition_used: BOOLEAN is false
			-- Is `position' used?

	INITIAL: INTEGER is 0
	UNSTRUCTURED_FIELD_BODY: INTEGER is 1
	STRUCTURED_FIELD_BODY: INTEGER is 2
	MIME_FIELD_BODY: INTEGER is 3
	PARAMETER: INTEGER is 4
	COMMENT: INTEGER is 5
	DOMAIN_LITERAL: INTEGER is 6
	NEXT_WORD: INTEGER is 7
	QUOTED_STRING: INTEGER is 8
	DATE: INTEGER is 9
			-- Start condition codes

feature -- User-defined features



feature {NONE} -- Initialization

	make is
		do
			precursor
			create last_integer
			create encoded_word_scanner.make
		end


feature -- Last returned data

	last_value: ANY


feature -- Input

	new_mime_request_buffer (a_stream: EPX_CHARACTER_INPUT_STREAM): EPX_MIME_BUFFER is
			-- New input buffer for `a_stream'.
		require
			stream_not_void: a_stream /= Void
			stream_open: a_stream.is_open_read
		do
			create Result.make (a_stream)
		ensure
			new_buffer_not_void: Result /= Void
		end


feature -- Condition setting

	expect_date is
		do
			set_start_condition (DATE)
		end

	reset_start_condition is
			-- Used in error recovery to return to start condition.
		do
			set_start_condition (INITIAL)
		end

	start_parameter is
		do
			to_condition := PARAMETER
			set_start_condition (PARAMETER)
		end


feature {NONE} -- Mime specific tokens

	mime_tokens: expanded EPX_MIME_TOKENS


feature {NONE} -- State during parsing

	call_enable_keyword_after_space: BOOLEAN
			-- Flag to call `enable_keyword_after_space' when encountered an ATOM.

	expect_keyword: BOOLEAN
			-- Treat certain atoms specially.

	expect_keyword_after_space: BOOLEAN
			-- Treat certain atoms specially after a space, crlf in
			-- folded-line or comment has been ecountered.

	to_condition: INTEGER
			-- Used by ':' to switch to correct field body parser.

	nested_comment_count: INTEGER
			-- Keep track of nested comments.

-- 	is_keyword (a_word: STRING): BOOLEAN is
-- 			-- True if `a_word' is in `keywords'.
-- 		local
-- 			upper_word: STRING
-- 		do
-- 			upper_word := clone (a_word)
-- 			upper_word.to_upper
-- 			keywords.search (upper_word)
-- 			Result := keywords.found
-- 		end

-- 	keywords: DS_HASH_TABLE [INTEGER, STRING] is
-- 			-- List of atoms that can be treated as a keyword.
-- 		once
-- 			create Result.make (64)
-- 			keywords.put (mime_tokens.KW_BY, "BY")
-- 			keywords.put (mime_tokens.KW_FOR, "FOR")
-- 			keywords.put (mime_tokens.KW_FROM, "FROM")
-- 			keywords.put (mime_tokens.KW_ID, "ID")
-- 			keywords.put (mime_tokens.KW_MULTIPART, "MULTIPART")
-- 			keywords.put (mime_tokens.KW_VIA, "VIA")
-- 			keywords.put (mime_tokens.KW_WITH, "WITH")
-- 		ensure
-- 			result_not_void: Result /= Void
-- 		end

	last_integer: INTEGER_REF

	last_string: STRING is
		do
			Result ?= last_value
		ensure
			last_string_returned: Result /= Void
		end

-- 	last_keyword: INTEGER is
-- 			-- Last keyword if `is_keyword' returned True.
-- 		do
-- 			Result := keywords.found_item
-- 		end

	set_last_integer (value: INTEGER) is
			-- Set `last_integer' and make sure `last_value' is this integer.
		do
			create last_integer
			last_integer.set_item (value)
			last_value := last_integer
		ensure
			new_integer: last_integer /= old last_integer
			value_set: last_integer.item = value
			last_value_is_integer: last_value = last_integer
		end

	prev_word_was_encoded: BOOLEAN
			-- Used to skip white space between encoded-words in an
			-- unstructured field.


feature {NONE} -- Implementation

	to_canonical_field_name (a_field_name: STRING): STRING is
			-- Turn `a_field_name' into a canonical field name. A
			-- canonical field name as the first character in uppercase
			-- and every character after a '-' as well. All other
			-- characters are lower case.
		require
			a_field_name_not_empty: a_field_name /= Void and then not a_field_name.is_empty
		local
			c,
			prev_c: CHARACTER
			i: INTEGER
		do
			create Result.make_from_string (a_field_name)
			prev_c := Result.item (1)
			Result.put (as_upper (prev_c), 1)
			from
				i := 2
			until
				i > Result.count
			loop
				c := Result.item (i)
				if prev_c = '-' then
					Result.put (as_upper (c), i)
				else
					Result.put (as_lower (c), i)
				end
				prev_c := c
				i := i + 1
			end
		end


feature {NONE} -- RFC 2047 encoded stuff handling

	encoded_word_scanner: EPX_MIME_ENCODED_WORD_SCANNER


invariant

	last_integer_not_void: last_integer /= Void
	never_a_keyword_in_start_condition:
		start_condition = INITIAL implies
			(not expect_keyword and not expect_keyword_after_space)
	encoded_word_scanner_not_void: encoded_word_scanner /= Void

end
